/*
   This version is not quite correct. It's correctness depends
   on the value of LINELEN. If LINELEN is greater than the
   length of any line in the file, then this program is correct
   (for that file). But if LINELEN is smaller than some line
   lengths, then this program will not count the number of
   lines correctly (why?).

   Try running this program with a small value for LINELEN.


   Prints to standard output the last ten lines of a text file.
   Reads from standard input unless there is a command-line
   argument, which should be the name of a text file.
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define  LINELEN  512

int main(int argc, char* argv[])
{
   int i;
   FILE *fp = stdin;
   int tail = 10;
   int lineCount = 0;
   char lineQueue[tail][LINELEN];

   if ( (1 < argc) && ((fp = fopen(argv[1], "r")) == NULL) )
   {
      char msg[BUFSIZ];
      sprintf(msg, "Problem with %s", argv[1]);
      perror(msg);
   }

   for (; fgets(lineQueue[lineCount % tail], LINELEN, fp); lineCount++);

   if (tail > lineCount) tail = lineCount;

   for (i = 0; i < tail; i++)
      printf("%s", lineQueue[(lineCount + i) % tail]);

   fclose( fp );
   return 0;
}
